/* ***********************************************************
 * This file was automatically generated on 2012-12-20.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

#ifndef BRICKLET_INDUSTRIAL_DIGITAL_IN_4_H
#define BRICKLET_INDUSTRIAL_DIGITAL_IN_4_H

#include "ip_connection.h"

/**
 * \defgroup BrickletIndustrialDigitalIn4 IndustrialDigitalIn4 Bricklet
 */

/**
 * \ingroup BrickletIndustrialDigitalIn4
 *
 * Device for controlling up to 4 optically coupled digital inputs
 */
typedef Device IndustrialDigitalIn4;

/**
 * \ingroup BrickletIndustrialDigitalIn4
 *
 * This callback is triggered whenever a change of the voltage level is detected
 * on pins where the interrupt was activated with {@link industrial_digital_in_4_set_interrupt}.
 * 
 * The values are a bitmask that specifies which interrupts occurred
 * and the current value bitmask.
 * 
 * For example:
 * 
 * * (1, 1) means that an interrupt on pin 0 occurred and
 *   currently pin 0 is high and pins 1-3 are low.
 * * (9, 14) means that interrupts on pins 0 and 3
 *   occurred and currently pin 0 is low and pins 1-3 are high.
 */
#define INDUSTRIAL_DIGITAL_IN_4_CALLBACK_INTERRUPT 9

/**
 * \ingroup BrickletIndustrialDigitalIn4
 *
 * Creates an object with the unique device ID \c uid. This object can then be
 * added to the IP connection.
 */
void industrial_digital_in_4_create(IndustrialDigitalIn4 *industrial_digital_in_4, const char *uid);

/**
 * \ingroup BrickletIndustrialDigitalIn4
 *
 * Returns the input value with a bitmask. The bitmask
 * is 16 bit long, *true* refers to high and *false* refers to 
 * low.
 * 
 * For example: The value 0b0000000000000011 means that pins 0-1 
 * are high and the other pins are low.
 * 
 * If no groups are used (see {@link industrial_digital_in_4_set_group}), the pins correspond to the
 * markings on the Digital In 4 Bricklet.
 * 
 * If groups are used, the pins correspond to the element in the group.
 * Element 1 in the group will get pins 0-3, element 2 pins 4-7, element 3
 * pins 8-11 and element 4 pins 12-15.
 */
int industrial_digital_in_4_get_value(IndustrialDigitalIn4 *industrial_digital_in_4, uint16_t *ret_value_mask);

/**
 * \ingroup BrickletIndustrialDigitalIn4
 *
 * Sets a group of Digital In 4 Bricklets that should work together. You can
 * find Bricklets that can be grouped together with {@link industrial_digital_in_4_get_available_for_group}.
 * 
 * The group consists of 4 elements. Element 1 in the group will get pins 0-3,
 * element 2 pins 4-7, element 3 pins 8-11 and element 4 pins 12-15.
 * 
 * Each element can either be one of the ports ('a' to 'd') or 'n' if it should
 * not be used.
 * 
 * For example: If you have two Digital In 4 Bricklets connected to port A and
 * port B respectively, you could call with "['a', 'b', 'n', 'n']".
 * 
 * Now the pins on the Digital In 4 on port A are assigned to 0-3 and the
 * pins on the Digital In 4 on port B are assigned to 4-7. It is now possible
 * to call {@link industrial_digital_in_4_get_value} and read out two Bricklets at the same time.
 */
int industrial_digital_in_4_set_group(IndustrialDigitalIn4 *industrial_digital_in_4, char group[4]);

/**
 * \ingroup BrickletIndustrialDigitalIn4
 *
 * Returns the group as set by {@link industrial_digital_in_4_set_group}
 */
int industrial_digital_in_4_get_group(IndustrialDigitalIn4 *industrial_digital_in_4, char ret_group[4]);

/**
 * \ingroup BrickletIndustrialDigitalIn4
 *
 * Returns a bitmask of ports that are available for grouping. For example the
 * value 0b0101 means: Port *A* and Port *C* are connected to Bricklets that
 * can be grouped together.
 */
int industrial_digital_in_4_get_available_for_group(IndustrialDigitalIn4 *industrial_digital_in_4, uint8_t *ret_available);

/**
 * \ingroup BrickletIndustrialDigitalIn4
 *
 * Sets the debounce period of the {@link INDUSTRIAL_DIGITAL_IN_4_CALLBACK_INTERRUPT} callback in ms.
 * 
 * For example: If you set this value to 100, you will get the interrupt
 * maximal every 100ms. This is necessary if something that bounces is
 * connected to the Digital In 4 Bricklet, such as a button.
 * 
 * The default value is 100.
 */
int industrial_digital_in_4_set_debounce_period(IndustrialDigitalIn4 *industrial_digital_in_4, uint32_t debounce);

/**
 * \ingroup BrickletIndustrialDigitalIn4
 *
 * Returns the debounce period as set by {@link industrial_digital_in_4_set_debounce_period}.
 */
int industrial_digital_in_4_get_debounce_period(IndustrialDigitalIn4 *industrial_digital_in_4, uint32_t *ret_debounce);

/**
 * \ingroup BrickletIndustrialDigitalIn4
 *
 * Sets the pins on which an interrupt is activated with a bitmask.
 * Interrupts are triggered on changes of the voltage level of the pin,
 * i.e. changes from high to low and low to high.
 * 
 * For example: An interrupt bitmask of 9 (0b0000000000001001) will 
 * enable the interrupt for pins 0 and 3.
 * 
 * The interrupts use the grouping as set by {@link industrial_digital_in_4_set_group}.
 * 
 * The interrupt is delivered with the callback {@link INDUSTRIAL_DIGITAL_IN_4_CALLBACK_INTERRUPT}.
 */
int industrial_digital_in_4_set_interrupt(IndustrialDigitalIn4 *industrial_digital_in_4, uint16_t interrupt_mask);

/**
 * \ingroup BrickletIndustrialDigitalIn4
 *
 * Returns the interrupt bitmask as set by {@link industrial_digital_in_4_set_interrupt}.
 */
int industrial_digital_in_4_get_interrupt(IndustrialDigitalIn4 *industrial_digital_in_4, uint16_t *ret_interrupt_mask);

/**
 * \ingroup BrickletIndustrialDigitalIn4
 *
 * Returns the name (including the hardware version), the firmware version
 * and the binding version of the device. The firmware and binding versions are
 * given in arrays of size 3 with the syntax [major, minor, revision].
 */
int industrial_digital_in_4_get_version(IndustrialDigitalIn4 *industrial_digital_in_4, char ret_name[40], uint8_t ret_firmware_version[3], uint8_t ret_binding_version[3]);

/**
 * \ingroup BrickletIndustrialDigitalIn4
 *
 * Registers a callback with ID \c id to the function \c callback.
 */
void industrial_digital_in_4_register_callback(IndustrialDigitalIn4 *industrial_digital_in_4, uint8_t id, void *callback);

#endif
