/* ***********************************************************
 * This file was automatically generated on 2012-12-20.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

#include "bricklet_io16.h"

#include <string.h>

#define FUNCTION_SET_PORT 1
#define FUNCTION_GET_PORT 2
#define FUNCTION_SET_PORT_CONFIGURATION 3
#define FUNCTION_GET_PORT_CONFIGURATION 4
#define FUNCTION_SET_DEBOUNCE_PERIOD 5
#define FUNCTION_GET_DEBOUNCE_PERIOD 6
#define FUNCTION_SET_PORT_INTERRUPT 7
#define FUNCTION_GET_PORT_INTERRUPT 8
#define FUNCTION_SET_PORT_MONOFLOP 10
#define FUNCTION_GET_PORT_MONOFLOP 11


typedef void (*interrupt_func_t)(char, uint8_t, uint8_t);

typedef void (*monoflop_done_func_t)(char, uint8_t, uint8_t);

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(push)
	#pragma pack(1)
	#define ATTRIBUTE_PACKED
#elif defined __GNUC__
	#define ATTRIBUTE_PACKED __attribute__((packed))
#else
	#error unknown compiler, do not know how to enable struct packing
#endif

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char port;
	uint8_t value_mask;
} ATTRIBUTE_PACKED SetPort_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char port;
} ATTRIBUTE_PACKED GetPort_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint8_t value_mask;
} ATTRIBUTE_PACKED GetPortReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char port;
	uint8_t pin_mask;
	char direction;
	bool value;
} ATTRIBUTE_PACKED SetPortConfiguration_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char port;
} ATTRIBUTE_PACKED GetPortConfiguration_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint8_t direction_mask;
	uint8_t value_mask;
} ATTRIBUTE_PACKED GetPortConfigurationReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t debounce;
} ATTRIBUTE_PACKED SetDebouncePeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetDebouncePeriod_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint32_t debounce;
} ATTRIBUTE_PACKED GetDebouncePeriodReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char port;
	uint8_t interrupt_mask;
} ATTRIBUTE_PACKED SetPortInterrupt_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char port;
} ATTRIBUTE_PACKED GetPortInterrupt_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint8_t interrupt_mask;
} ATTRIBUTE_PACKED GetPortInterruptReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char port;
	uint8_t interrupt_mask;
	uint8_t value_mask;
} ATTRIBUTE_PACKED InterruptCallback_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char port;
	uint8_t pin_mask;
	uint8_t value_mask;
	uint32_t time;
} ATTRIBUTE_PACKED SetPortMonoflop_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char port;
	uint8_t pin;
} ATTRIBUTE_PACKED GetPortMonoflop_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint8_t value;
	uint32_t time;
	uint32_t time_remaining;
} ATTRIBUTE_PACKED GetPortMonoflopReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char port;
	uint8_t pin_mask;
	uint8_t value_mask;
} ATTRIBUTE_PACKED MonoflopDoneCallback_;

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(pop)
#endif
#undef ATTRIBUTE_PACKED

int io16_set_port(IO16 *io16, char port, uint8_t value_mask) {
	if(io16->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&io16->write_mutex);

	SetPort_ sp;
	sp.stack_id = io16->stack_id;
	sp.function_id = FUNCTION_SET_PORT;
	sp.length = ipcon_leconvert_uint16_to(sizeof(SetPort_));
	sp.port = port;
	sp.value_mask = value_mask;

	ipcon_device_write(io16, (char *)&sp, sizeof(SetPort_));

	ipcon_mutex_unlock(&io16->write_mutex);

	return E_OK;
}

int io16_get_port(IO16 *io16, char port, uint8_t *ret_value_mask) {
	if(io16->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&io16->write_mutex);

	io16->response.function_id = FUNCTION_GET_PORT;
	io16->response.length = sizeof(GetPortReturn_);
	GetPort_ gp;
	gp.stack_id = io16->stack_id;
	gp.function_id = FUNCTION_GET_PORT;
	gp.length = ipcon_leconvert_uint16_to(sizeof(GetPort_));
	gp.port = port;

	ipcon_device_write(io16, (char *)&gp, sizeof(GetPort_));

	if(ipcon_device_expect_response(io16) != 0) {
		ipcon_mutex_unlock(&io16->write_mutex);
		return E_TIMEOUT;
	}

	GetPortReturn_ *gpr = (GetPortReturn_ *)io16->response.buffer;
	*ret_value_mask = gpr->value_mask;

	ipcon_mutex_unlock(&io16->write_mutex);

	return E_OK;
}

int io16_set_port_configuration(IO16 *io16, char port, uint8_t pin_mask, char direction, bool value) {
	if(io16->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&io16->write_mutex);

	SetPortConfiguration_ spc;
	spc.stack_id = io16->stack_id;
	spc.function_id = FUNCTION_SET_PORT_CONFIGURATION;
	spc.length = ipcon_leconvert_uint16_to(sizeof(SetPortConfiguration_));
	spc.port = port;
	spc.pin_mask = pin_mask;
	spc.direction = direction;
	spc.value = value;

	ipcon_device_write(io16, (char *)&spc, sizeof(SetPortConfiguration_));

	ipcon_mutex_unlock(&io16->write_mutex);

	return E_OK;
}

int io16_get_port_configuration(IO16 *io16, char port, uint8_t *ret_direction_mask, uint8_t *ret_value_mask) {
	if(io16->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&io16->write_mutex);

	io16->response.function_id = FUNCTION_GET_PORT_CONFIGURATION;
	io16->response.length = sizeof(GetPortConfigurationReturn_);
	GetPortConfiguration_ gpc;
	gpc.stack_id = io16->stack_id;
	gpc.function_id = FUNCTION_GET_PORT_CONFIGURATION;
	gpc.length = ipcon_leconvert_uint16_to(sizeof(GetPortConfiguration_));
	gpc.port = port;

	ipcon_device_write(io16, (char *)&gpc, sizeof(GetPortConfiguration_));

	if(ipcon_device_expect_response(io16) != 0) {
		ipcon_mutex_unlock(&io16->write_mutex);
		return E_TIMEOUT;
	}

	GetPortConfigurationReturn_ *gpcr = (GetPortConfigurationReturn_ *)io16->response.buffer;
	*ret_direction_mask = gpcr->direction_mask;
	*ret_value_mask = gpcr->value_mask;

	ipcon_mutex_unlock(&io16->write_mutex);

	return E_OK;
}

int io16_set_debounce_period(IO16 *io16, uint32_t debounce) {
	if(io16->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&io16->write_mutex);

	SetDebouncePeriod_ sdp;
	sdp.stack_id = io16->stack_id;
	sdp.function_id = FUNCTION_SET_DEBOUNCE_PERIOD;
	sdp.length = ipcon_leconvert_uint16_to(sizeof(SetDebouncePeriod_));
	sdp.debounce = ipcon_leconvert_uint32_to(debounce);

	ipcon_device_write(io16, (char *)&sdp, sizeof(SetDebouncePeriod_));

	ipcon_mutex_unlock(&io16->write_mutex);

	return E_OK;
}

int io16_get_debounce_period(IO16 *io16, uint32_t *ret_debounce) {
	if(io16->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&io16->write_mutex);

	io16->response.function_id = FUNCTION_GET_DEBOUNCE_PERIOD;
	io16->response.length = sizeof(GetDebouncePeriodReturn_);
	GetDebouncePeriod_ gdp;
	gdp.stack_id = io16->stack_id;
	gdp.function_id = FUNCTION_GET_DEBOUNCE_PERIOD;
	gdp.length = ipcon_leconvert_uint16_to(sizeof(GetDebouncePeriod_));

	ipcon_device_write(io16, (char *)&gdp, sizeof(GetDebouncePeriod_));

	if(ipcon_device_expect_response(io16) != 0) {
		ipcon_mutex_unlock(&io16->write_mutex);
		return E_TIMEOUT;
	}

	GetDebouncePeriodReturn_ *gdpr = (GetDebouncePeriodReturn_ *)io16->response.buffer;
	*ret_debounce = ipcon_leconvert_uint32_from(gdpr->debounce);

	ipcon_mutex_unlock(&io16->write_mutex);

	return E_OK;
}

int io16_set_port_interrupt(IO16 *io16, char port, uint8_t interrupt_mask) {
	if(io16->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&io16->write_mutex);

	SetPortInterrupt_ spi;
	spi.stack_id = io16->stack_id;
	spi.function_id = FUNCTION_SET_PORT_INTERRUPT;
	spi.length = ipcon_leconvert_uint16_to(sizeof(SetPortInterrupt_));
	spi.port = port;
	spi.interrupt_mask = interrupt_mask;

	ipcon_device_write(io16, (char *)&spi, sizeof(SetPortInterrupt_));

	ipcon_mutex_unlock(&io16->write_mutex);

	return E_OK;
}

int io16_get_port_interrupt(IO16 *io16, char port, uint8_t *ret_interrupt_mask) {
	if(io16->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&io16->write_mutex);

	io16->response.function_id = FUNCTION_GET_PORT_INTERRUPT;
	io16->response.length = sizeof(GetPortInterruptReturn_);
	GetPortInterrupt_ gpi;
	gpi.stack_id = io16->stack_id;
	gpi.function_id = FUNCTION_GET_PORT_INTERRUPT;
	gpi.length = ipcon_leconvert_uint16_to(sizeof(GetPortInterrupt_));
	gpi.port = port;

	ipcon_device_write(io16, (char *)&gpi, sizeof(GetPortInterrupt_));

	if(ipcon_device_expect_response(io16) != 0) {
		ipcon_mutex_unlock(&io16->write_mutex);
		return E_TIMEOUT;
	}

	GetPortInterruptReturn_ *gpir = (GetPortInterruptReturn_ *)io16->response.buffer;
	*ret_interrupt_mask = gpir->interrupt_mask;

	ipcon_mutex_unlock(&io16->write_mutex);

	return E_OK;
}

int io16_set_port_monoflop(IO16 *io16, char port, uint8_t pin_mask, uint8_t value_mask, uint32_t time) {
	if(io16->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&io16->write_mutex);

	SetPortMonoflop_ spm;
	spm.stack_id = io16->stack_id;
	spm.function_id = FUNCTION_SET_PORT_MONOFLOP;
	spm.length = ipcon_leconvert_uint16_to(sizeof(SetPortMonoflop_));
	spm.port = port;
	spm.pin_mask = pin_mask;
	spm.value_mask = value_mask;
	spm.time = ipcon_leconvert_uint32_to(time);

	ipcon_device_write(io16, (char *)&spm, sizeof(SetPortMonoflop_));

	ipcon_mutex_unlock(&io16->write_mutex);

	return E_OK;
}

int io16_get_port_monoflop(IO16 *io16, char port, uint8_t pin, uint8_t *ret_value, uint32_t *ret_time, uint32_t *ret_time_remaining) {
	if(io16->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&io16->write_mutex);

	io16->response.function_id = FUNCTION_GET_PORT_MONOFLOP;
	io16->response.length = sizeof(GetPortMonoflopReturn_);
	GetPortMonoflop_ gpm;
	gpm.stack_id = io16->stack_id;
	gpm.function_id = FUNCTION_GET_PORT_MONOFLOP;
	gpm.length = ipcon_leconvert_uint16_to(sizeof(GetPortMonoflop_));
	gpm.port = port;
	gpm.pin = pin;

	ipcon_device_write(io16, (char *)&gpm, sizeof(GetPortMonoflop_));

	if(ipcon_device_expect_response(io16) != 0) {
		ipcon_mutex_unlock(&io16->write_mutex);
		return E_TIMEOUT;
	}

	GetPortMonoflopReturn_ *gpmr = (GetPortMonoflopReturn_ *)io16->response.buffer;
	*ret_value = gpmr->value;
	*ret_time = ipcon_leconvert_uint32_from(gpmr->time);
	*ret_time_remaining = ipcon_leconvert_uint32_from(gpmr->time_remaining);

	ipcon_mutex_unlock(&io16->write_mutex);

	return E_OK;
}

int io16_get_version(IO16 *io16, char ret_name[40], uint8_t ret_firmware_version[3], uint8_t ret_binding_version[3]) {
	strncpy(ret_name, io16->name, 40);

	ret_firmware_version[0] = io16->firmware_version[0];
	ret_firmware_version[1] = io16->firmware_version[1];
	ret_firmware_version[2] = io16->firmware_version[2];

	ret_binding_version[0] = io16->binding_version[0];
	ret_binding_version[1] = io16->binding_version[1];
	ret_binding_version[2] = io16->binding_version[2];

	return E_OK;
}

static int io16_callback_wrapper_interrupt(IO16 *io16, const unsigned char *buffer) {
	InterruptCallback_ *ic = (InterruptCallback_ *)buffer;

	((interrupt_func_t)io16->registered_callbacks[ic->function_id])(ic->port, ic->interrupt_mask, ic->value_mask);
	return sizeof(InterruptCallback_);
}

static int io16_callback_wrapper_monoflop_done(IO16 *io16, const unsigned char *buffer) {
	MonoflopDoneCallback_ *mdc = (MonoflopDoneCallback_ *)buffer;

	((monoflop_done_func_t)io16->registered_callbacks[mdc->function_id])(mdc->port, mdc->pin_mask, mdc->value_mask);
	return sizeof(MonoflopDoneCallback_);
}

void io16_register_callback(IO16 *io16, uint8_t id, void *callback) {
	io16->registered_callbacks[id] = callback;
}

void io16_create(IO16 *io16, const char *uid) {
	ipcon_device_create(io16, uid);

	io16->expected_name = "IO-16 Bricklet";

	io16->binding_version[0] = 1;
	io16->binding_version[1] = 0;
	io16->binding_version[2] = 1;

	io16->callback_wrappers[IO16_CALLBACK_INTERRUPT] = io16_callback_wrapper_interrupt;
	io16->callback_wrappers[IO16_CALLBACK_MONOFLOP_DONE] = io16_callback_wrapper_monoflop_done;
}
